"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const core_1 = require("@context-experiments/core");
const context_1 = __importDefault(require("../../context"));
const useFeature = (featureReadableId) => {
    const hash = react_1.useRef(`${Math.random()}`);
    const engine = react_1.useContext(context_1.default);
    react_1.useEffect(() => {
        const currentHash = hash.current;
        return () => {
            try {
                engine.unregisterCaller(currentHash);
            }
            catch (_a) { }
        };
    }, [engine]);
    try {
        const { isActive, givenValue, metaData } = engine.getFeature(featureReadableId, hash.current);
        return [isActive, givenValue, metaData];
    }
    catch (_a) { }
    return [core_1.fallbackFeature.isActive, core_1.fallbackFeature.givenValue, core_1.fallbackFeature.metaData];
};
exports.default = useFeature;
//# sourceMappingURL=index.js.map